declare type _Aperture_ = <T>(chunkSize: number, arr: T[]) => T[][];
declare type _Aperture2_ = <T>(chunkSize: number) => (arr: T[]) => T[][];
declare type Aperture_ = _Aperture_ & _Aperture2_;
/**
 * Splits the array into overlapping chunks of a provided size (shifted by one).
 *
 * @param chunkSize Chunk size
 * @param arr Initial array
 * @returns New array of chunks
 */
declare const aperture_: Aperture_;
export { aperture_ };
export default aperture_;
