declare type _Append_ = <T>(value: T, arr: T[]) => T[];
declare type _Append2_ = <T>(value: T) => (arr: T[]) => T[];
declare type Append_ = _Append_ & _Append2_;
/**
 * Adds a value at the end of the array.
 * Similar to Array.prototype.push, but immutable.
 *
 * @param value Additional value
 * @param arr Initial array
 * @returns New array
 */
declare const append_: Append_;
export { append_ };
export default append_;
