"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const curry_1 = require("@arrows/composition/curry");
const _append_ = (value, arr) => arr.concat([value]);
/**
 * Adds a value at the end of the array.
 * Similar to Array.prototype.push, but immutable.
 *
 * @param value Additional value
 * @param arr Initial array
 * @returns New array
 */
const append_ = curry_1.default(_append_);
exports.append_ = append_;
exports.default = append_;
