declare type _Chunk_ = <T>(chunkSize: number, arr: T[]) => T[][];
declare type _Chunk2_ = <T>(chunkSize: number) => (arr: T[]) => T[][];
declare type Chunk_ = _Chunk_ & _Chunk2_;
/**
 * Splits the array into chunks of a provided size.
 *
 * @param chunkSize Chunk size
 * @param arr Initial array
 * @returns New array of chunks
 */
declare const chunk_: Chunk_;
export { chunk_ };
export default chunk_;
