"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const curry_1 = require("@arrows/composition/curry");
const _every = (testFn, arr) => arr.every(testFn);
/**
 * Functional wrapper for Array.prototype.every
 *
 * Determines whether all the members of an array satisfy the specified test.
 *
 * @param testFn Test function
 * @param arr Initial array
 * @returns True if all elements satisfy test function, false otherwise
 */
const every = curry_1.default(_every);
exports.every = every;
exports.default = every;
