"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const curry_1 = require("@arrows/composition/curry");
const _forEach = (sideEffectFn, arr) => arr.forEach(sideEffectFn);
/**
 * Functional wrapper for Array.prototype.forEach
 *
 * Performs the specified side effect action for each element in an array.
 *
 * @param sideEffectFn Side effect function
 * @param arr Initial array
 * @returns Nothing (undefined)
 */
const forEach = curry_1.default(_forEach);
exports.forEach = forEach;
exports.default = forEach;
