declare type _SetSize_ = <T>(size: number, arr: T[]) => (T | undefined)[];
declare type _SetSize2_ = <T>(size: number) => (arr: T[]) => (T | undefined)[];
declare type SetSize_ = _SetSize_ & _SetSize2_;
/**
 * Creates a new array trimmed/extended to a provided size.
 * If the new array is longer than the initial one,
 * additional indexes will be set to undefined.
 *
 * @param size Required size
 * @param arr Initial array
 * @returns New array
 */
declare const setSize_: SetSize_;
export { setSize_ };
export default setSize_;
