/**
 * Returns the type of a value (using the internal `[[Class]]` property).
 *
 * It does not return custom prototypes - if you need that, use `is` function.
 *
 * @see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/toString#Using_toString_to_detect_object_class
 * @see `types` module for the most common values
 */
declare const getType: (value: any) => string;
export { getType };
export default getType;
