"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const isConstructor_1 = require("./isConstructor");
const createCaseEntry = (caseValue) => {
    if (isConstructor_1.default(caseValue)) {
        return { type: 'constructor', value: caseValue };
    }
    if (typeof caseValue === 'function') {
        return { type: 'function', value: caseValue };
    }
    if (Array.isArray(caseValue) &&
        caseValue.some((item) => isConstructor_1.default(item))) {
        return {
            type: 'mixed',
            values: caseValue.map((item) => {
                return {
                    type: isConstructor_1.default(item) ? 'constructor' : 'value',
                    value: item,
                };
            }),
        };
    }
    return {
        type: 'value',
        value: caseValue,
    };
};
exports.default = createCaseEntry;
