import { multimethodKey } from './multimethod';
declare type Class<T> = new (...args: any[]) => T;
export declare type Dispatch = (...args: any[]) => any;
export declare type MethodEntry = [any, any];
export declare type MethodEntries = MethodEntry[];
export declare type DefaultMethod = ((arg0: any, arg1?: any) => any) | null;
export declare type ValueCaseEntry = {
    type: 'value';
    value: any;
};
export declare type ConstructorCaseEntry = {
    type: 'constructor';
    value: new (...args: any[]) => Class<any>;
};
export declare type FunctionCaseEntry = {
    type: 'function';
    value: (...args: any[]) => boolean;
};
export declare type MixedCaseEntry = {
    type: 'mixed';
    values: Array<ConstructorCaseEntry | ValueCaseEntry>;
};
export declare type CaseEntry = ValueCaseEntry | ConstructorCaseEntry | FunctionCaseEntry | MixedCaseEntry;
export declare type Internals = {
    methodEntries: MethodEntries;
    defaultMethod: DefaultMethod;
    dispatch: Dispatch;
};
export declare type Multi = {
    [multimethodKey]: Internals;
};
export declare type Multimethod = ((...args: any[]) => any) & Multi;
export declare type MethodFn = (arg0: any, arg1?: any) => (multimethod: Multimethod) => Multimethod;
export declare type MultiFn = (arg0?: Dispatch | MethodFn, ...methods: MethodFn[]) => Multimethod;
export {};
